{ fp }
{$B-,O+,R-,H+}
{$M 20000000,0,20000000}
const maxMN			   = 500;
   dr:	    array[1..4] of longint = (-1,0,0,1);
   dc:	    array[1..4] of longint = (0,-1,1,0);
type TEdge = record 	
		v,w,len	: longint;
	     end;	
	   
   TDSNode = record
		parent,rank : longint;
	     end;	    
var n,m,ans,ucnt       : longint;	     
   field	       : array [1..maxMN] of String;
   island	       : array [1..maxMN,1..maxMN] of longint;
   i,j,qb,qe,r,c,d,beg : longint;	     
   ifs,ofs	       : text;		     
   iCnt,eCnt	       : longint;	     
   q		       : array [1..maxMN*maxMN,1..2] of longint;
   edges	       : array [1..maxMN*maxMN] of TEdge;
   nds		       : array [1..maxMN*maxMN] of TDSNode;
function DSRepr(x      : longint):longint;
begin
   if nds[x].parent=x then DSRepr:=x
   else begin
      nds[x].parent:=DSRepr(nds[x].parent);
      DSRepr:=nds[x].parent;
   end;
end; { DSRepr }
function DSUnion(x,y : longint):boolean;
begin
   x:=DSRepr(x);
   y:=DSRepr(y);
   if x=y then DSUnion:=false
   else begin
      if nds[y].rank>nds[x].rank then begin
	 x:=x xor y;y:=x xor y;x:=x xor y;
      end;
      if nds[x].rank=nds[y].rank then inc(nds[x].rank);
      nds[y].parent:=x;
      DSUnion:=true;
   end;
end; { DSUnion }
procedure SortEdges;
   procedure Swap(i,j : longint);
   var tmp : TEdge;
   begin
      tmp:=edges[i];
      edges[i]:=edges[j];
      edges[j]:=tmp;
   end; { Swap }
   procedure Heapify(i,max : longint);
   var j : longint;
   begin
      while 2*i<=max do begin
	 j:=2*i;
	 if (j+1<=max) and (edges[j].len<=edges[j+1].len) then inc(j);
	 if edges[i].len<edges[j].len then begin
	    Swap(i,j);
	    i:=j;
	 end
	 else i:=max+1;
      end;
   end; { Heapify }
var i : longint;
begin
   for i:= eCnt div 2 downto 1 do Heapify(i,eCnt);
   for i:= eCnt downto 2 do begin
      Swap(1,i);
      Heapify(1,i-1);
   end;
end; { SortEdges }

begin
   assign(ifs,'islands.dat');
   reset(ifs);
   assign(ofs,'islands.sol');
   rewrite(ofs);

   readln(ifs,n,m);
   for i:=1 to n do readln(ifs,field[i]);
   iCnt:=0;
   fillchar(island,sizeof(island),0);
   {Finding islands}
   for i:=1 to n do
      for j:=1 to m do
	 if (field[i][j]='1') and (island[i,j]=0) then begin
	    inc(iCnt);
	    qb:=1;qe:=1;
	    island[i,j]:=iCnt;
	    q[qe,1]:=i;q[qe,2]:=j;inc(qe);
	    while qb<>qe do begin
	       r:=q[qb,1];c:=q[qb,2];inc(qb);
	       for d:=1 to 4 do
		  if (r+dr[d]>0)and(r+dr[d]<=n)and(c+dc[d]>0)and(c+dc[d]<=m)and
		     (field[r+dr[d]][c+dc[d]]='1')and(island[r+dr[d],c+dc[d]]=0) then begin
			island[r+dr[d],c+dc[d]]:=iCnt;
			q[qe,1]:=r+dr[d];q[qe,2]:=c+dc[d];inc(qe);
		     end;
	    end;
	 end;
   { Finding possible bridges }
   eCnt:=0;
   for i:=1 to n do begin
      beg:=n+5;
      for j:=1 to m do
	 if field[i][j]='1' then begin
	    if (j-beg>1) and (island[i,j]<>island[i,beg]) then begin
	       inc(eCnt);
	       edges[eCnt].v:=island[i,j];edges[eCnt].w:=island[i,beg];edges[eCnt].len:=j-beg-1;
	    end;
	    beg:=j;
	 end;
   end;
   for j:=1 to m do begin
      beg:=m+5;
      for i:=1 to n do
	 if field[i][j]='1' then begin
	    if (i-beg>1) and (island[i,j]<>island[beg,j]) then begin
	       inc(eCnt);
	       edges[eCnt].v:=island[i,j];edges[eCnt].w:=island[beg,j];edges[eCnt].len:=i-beg-1;
	    end;
	    beg:=i;
	 end;
   end;
   
   SortEdges;

   { Kruskal's algo }
   for i:=1 to iCnt do begin
      nds[i].parent:=i;
      nds[i].rank:=0;
   end;
   ans:=0;
   ucnt:=0;
   for i:=1 to eCnt do begin
      if DSUnion(edges[i].v,edges[i].w) then begin
	 inc(ans,edges[i].len);
	 inc(ucnt);
      end;
   end;
   if ucnt=iCnt-1 then writeln(ofs,ans)
   else writeln(ofs,'-1');
   close(ifs);
   close(ofs);
end.