/* gcc_cpp */
#include <cstdio>
#include <algorithm>

using namespace std;

const char *infile="islands.dat";
const char *outfile="islands.sol";

const int maxMN=500;
const int maxIslands=500;
const int maxE=maxMN*maxMN;
const int inf=1000000000;
const int dr[4]={-1,0,0,1};
const int dc[4]={0,-1,1,0};

struct edge {
    int v,w,len;
    edge(int V=0,int W=0,int Len=0):v(V),w(W),len(Len) {}
    bool operator<(const edge &e)const {return len<e.len;}
};

char field[maxMN][maxMN+5];
int n,m,iCnt;
int island[maxMN][maxMN];
int q[maxMN*maxMN][2];
edge edges[maxE];
int eCnt;
int adj[maxIslands+1][maxIslands+1];
int ans=inf;

bool find_way(int v,int targ) {
    int q[maxIslands+1];
    int qb,qe,i;
    int visited[maxIslands+1];
    for(i=1;i<=iCnt;i++)visited[i]=0;
    qb=qe=0;
    q[qe++]=v;
    visited[v]=1;
    while(qb!=qe&&!visited[targ]) {
        v=q[qb++];
        for(i=1;i<=iCnt;i++)
            if(adj[v][i]&&!visited[i]) {
                visited[i]=1;
                q[qe++]=i;
            }
    }
    return visited[targ];
}

void solve(int k,int ec,int ecost) {
    if(k==eCnt) {
        if(ec==iCnt-1&&ans>ecost)ans=ecost;
    }
    else if(ec+(eCnt-k)>=iCnt-1) {
        solve(k+1,ec,ecost);
        if(!find_way(edges[k].v,edges[k].w)) {
            adj[edges[k].v][edges[k].w]=adj[edges[k].w][edges[k].v]=1;
            solve(k+1,ec+1,ecost+edges[k].len);
            adj[edges[k].v][edges[k].w]=adj[edges[k].w][edges[k].v]=0;
        }
    }
}

int main() {
    int i,j,beg,r,c;
    int qb,qe,d;
    FILE *ifs=fopen(infile,"r");
    FILE *ofs=fopen(outfile,"w");
    
    fscanf(ifs,"%d%d\n",&n,&m);
    for(i=0;i<n;i++)
        fscanf(ifs," %s",field[i]);
    iCnt=0;
    for(i=0;i<n;i++)
        for(j=0;j<m;j++)
            if(field[i][j]=='1'&&!island[i][j]) {
				qb=qe=0;++iCnt;
				q[qe][0]=i;q[qe][1]=j;qe++;
				island[i][j]=iCnt;
                while(qb!=qe) {
					r=q[qb][0];c=q[qb][1];qb++;
					for(d=0;d<4;d++)
        				if(r+dr[d]>=0&&r+dr[d]<n&&c+dc[d]>=0&&c+dc[d]<m&&
            				field[r+dr[d]][c+dc[d]]=='1'&&!island[r+dr[d]][c+dc[d]]) {
								island[r+dr[d]][c+dc[d]]=iCnt;
								q[qe][0]=r+dr[d];q[qe][1]=c+dc[d];qe++;
                			}
				}
			}
	eCnt=0;
    for(i=0;i<n;i++) {
        for(beg=m+1,j=0;j<m;j++)
            if(field[i][j]=='1') {
                if(j-beg>1&&island[i][j]!=island[i][beg])
                    edges[eCnt++]=edge(island[i][j],island[i][beg],j-beg-1);
                beg=j;
            }
    }            
    for(j=0;j<m;j++) {
        for(beg=n+1,i=0;i<n;i++)
            if(field[i][j]=='1') {
                if(i-beg>1&&island[i][j]!=island[beg][j])
                    edges[eCnt++]=edge(island[i][j],island[beg][j],i-beg-1);
                beg=i;
            }
    }
    solve(0,0,0);
    
       
//    ans=0;uCnt=0;
//    sort(edges,edges+eCnt);
//
//    for(i=1;i<=iCnt;i++) {
//        nds[i].parent=i;
//        nds[i].rank=0;
//    }
//    for(i=0;i<eCnt;i++) 
//        if(DSUnion(edges[i].v,edges[i].w)) {
//            uCnt++;
//            ans+=edges[i].len;
//        }
    if(ans!=inf)fprintf(ofs,"%d\n",ans);
    else fprintf(ofs,"-1\n");	
    fclose(ifs);
    fclose(ofs);
    return 0;   
}
