/* vc_cpp */
#include <cstdio>
#include <algorithm>

using namespace std;

const char *infile="islands.dat";
const char *outfile="islands.sol";

const int maxMN=500;
const int maxIslands=maxMN*maxMN;
const int maxE=maxMN*maxMN;
const int dr[4]={-1,0,0,1};
const int dc[4]={0,-1,1,0};

struct edge {
    int v,w,len;
    edge(int V=0,int W=0,int Len=0):v(V),w(W),len(Len) {}
    bool operator<(const edge &e)const {return len<e.len;}
};
struct DSNode {
    int parent,rank;
};

char field[maxMN][maxMN+5];
int n,m;
int island[maxMN][maxMN];
int q[maxMN*maxMN][2];
edge edges[maxE];
DSNode nds[maxIslands+1];
int stk[maxIslands];

inline int DSRepr(int x) {
    int stkPtr=0;
    for(;nds[x].parent!=x;x=nds[x].parent) 
        stk[stkPtr++]=x;
    while(stkPtr>0)nds[stk[--stkPtr]].parent=x;
    return x;
}
inline bool DSUnion(int x,int y) {
    x=DSRepr(x);
    y=DSRepr(y);
    if(x==y)return false;
    else {
        if(nds[y].rank>nds[x].rank)swap(x,y);
        if(nds[x].rank==nds[y].rank)nds[x].rank++;
        nds[y].parent=x;
        return true;
    }
}
int main() {
    int i,j,beg,r,c;
    int iCnt,eCnt,qb,qe;
    int ans,d,uCnt;
    FILE *ifs=fopen(infile,"r");
    FILE *ofs=fopen(outfile,"w");
    
    fscanf(ifs,"%d%d\n",&n,&m);
    for(i=0;i<n;i++)
        fscanf(ifs," %s",field[i]);
    iCnt=0;
    for(i=0;i<n;i++)
        for(j=0;j<m;j++)
            if(field[i][j]=='1'&&!island[i][j]) {
				qb=qe=0;++iCnt;
				q[qe][0]=i;q[qe][1]=j;qe++;
				island[i][j]=iCnt;
                while(qb!=qe) {
					r=q[qb][0];c=q[qb][1];qb++;
					for(d=0;d<4;d++)
        				if(r+dr[d]>=0&&r+dr[d]<n&&c+dc[d]>=0&&c+dc[d]<m&&
            				field[r+dr[d]][c+dc[d]]=='1'&&!island[r+dr[d]][c+dc[d]]) {
								island[r+dr[d]][c+dc[d]]=iCnt;
								q[qe][0]=r+dr[d];q[qe][1]=c+dc[d];qe++;
                			}
				}
			}
	eCnt=0;
    for(i=0;i<n;i++) {
        for(beg=m+1,j=0;j<m;j++)
            if(field[i][j]=='1') {
                if(j-beg>1&&island[i][j]!=island[i][beg])
                    edges[eCnt++]=edge(island[i][j],island[i][beg],j-beg-1);
                beg=j;
            }
    }            
    for(j=0;j<m;j++) {
        for(beg=n+1,i=0;i<n;i++)
            if(field[i][j]=='1') {
                if(i-beg>1&&island[i][j]!=island[beg][j])
                    edges[eCnt++]=edge(island[i][j],island[beg][j],i-beg-1);
                beg=i;
            }
    }
    ans=0;uCnt=0;
    sort(edges,edges+eCnt);

    for(i=1;i<=iCnt;i++) {
        nds[i].parent=i;
        nds[i].rank=0;
    }
    for(i=0;i<eCnt;i++)
        if(DSUnion(edges[i].v,edges[i].w)) {
            uCnt++;
            ans+=edges[i].len;
        }
    if(uCnt+1==iCnt)fprintf(ofs,"%d\n",ans);
    else fprintf(ofs,"-1\n");	
    fclose(ifs);
    fclose(ofs);
    return 0;   
}
