/* gcc_cpp */
#include <algorithm>
#include <cstdio>

using namespace std;

const char *infile="points.dat";
const char *outfile="points.sol";

const int maxN=10000;

#define BETWEEN(a,x,b) ((a)<=(x)&&(x)<=(b)||(a)>=(x)&&(x)>=(b))
struct point {
    int x,y;
    point(int X=0,int Y=0):x(X),y(Y) {}
    point operator-(const point &p)const {return point(x-p.x,y-p.y);}    
    int operator*(const point &p)const {return x*p.y-p.x*y;}  // vector multiplication
    FILE *read(FILE *f) {
        fscanf(f,"%d%d",&x,&y);
        return f;
    }
    bool inrect(const point &r1,const point &r2)const {
        return BETWEEN(r1.x,x,r2.x)&&BETWEEN(r1.y,y,r2.y);
    }
};
struct event {
    point alpha;
    int type;
    event(point P=point(0,0),int Type=0):alpha(P),type(Type) {}
    bool operator<(const event &e)const {return alpha*e.alpha>0||alpha*e.alpha==0&&type<e.type;}
};

event e[2*maxN];

int main()
{
    int n,i,ec;
    int ans,cur;
    point c1,c2,p;
    FILE *ifs=fopen(infile,"r");
    FILE *ofs=fopen(outfile,"w");
    
    fscanf(ifs,"%d",&n);
    c1.read(ifs);c2.read(ifs);
    for(i=0;i<n;i++)
    for(i=0,ec=0,cur=0;i<n;i++) {
        p.read(ifs);
        if((c2-c1)*(p-c1)>0) {
            e[ec++]=event(p-c1,0);
            e[ec++]=event(p-c2,1);
        }
        else if((c2-c1)*(p-c1)<0) {
            e[ec++]=event(c2-p,0);
            e[ec++]=event(c1-p,1);
        }
        else if(p.inrect(c1,c2))cur++;
        else {
            e[ec++]=event(p-c1,0);
            e[ec++]=event(p-c2,1);
        }
    }
    sort(e,e+ec);    
    ans=cur;
    for(i=0;i<ec;i++) {
        if(e[i].type==0)cur++;
        else cur--;
        ans=max(ans,cur);
    }
    fprintf(ofs,"%d\n",ans);
    fclose(ifs);
    fclose(ofs);	
	return 0;
}
