/* gcc_cpp */
#include <cstdio>
#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

const char *infile="genome.dat";
const char *outfile="genome.sol";

const int maxN=10000;

typedef long long ll;

int n;

struct {
    int s,f,a,b;
} sets[maxN];

inline bool InSet(int k,int x) {
    if(x<sets[k].s||x>sets[k].f)return false;
    int p=sets[k].s+(sets[k].a+sets[k].b)*((x-sets[k].s)/(sets[k].a+sets[k].b));
    return x<p+sets[k].a;
}

int main() {
    int i,j,cnt;
    FILE *ifs=fopen(infile,"r");
    FILE *ofs=fopen(outfile,"w");
    vector<int> cands;
    fscanf(ifs,"%d",&n);
    for(i=0;i<n;i++) {
        fscanf(ifs,"%d%d%d%d",&sets[i].s,&sets[i].f,&sets[i].a,&sets[i].b);
        cands.push_back(sets[i].s);
        cands.push_back(sets[i].s-sets[i].a);
        cands.push_back(sets[i].s-2*sets[i].a);
        cands.push_back(sets[i].f);
        cands.push_back(sets[i].s+(sets[i].a+sets[i].b)*((sets[i].f-sets[i].s)/(sets[i].a+sets[i].b)));
        cands.push_back(sets[i].s+(sets[i].a+sets[i].b)*((sets[i].f-sets[i].s)/(sets[i].a+sets[i].b)+1));
        cands.push_back(sets[i].s+(sets[i].a+sets[i].b)*((sets[i].f-sets[i].s)/(sets[i].a+sets[i].b)+2));
        cands.push_back(sets[i].s-1);
        cands.push_back(sets[i].f+1);
        cands.push_back(sets[i].s-2);
        cands.push_back(sets[i].f+2);
    }
    sort(cands.begin(),cands.end());
    cands.resize(unique(cands.begin(),cands.end())-cands.begin());
    for(i=cands.size()-1;i>=0;i--) {
        for(j=0,cnt=0;j<n;j++)
            cnt+=InSet(j,cands[i]);
        if(cnt%2){fprintf(ofs,"%d\n",cands[i]);return 0;}
    }
    fprintf(ofs,"0\n");
    fclose(ifs);
    fclose(ofs);
    return 0;
}
